package simplerace;

/**
 * Created by IntelliJ IDEA.
 * User: Pete
 * Date: 15-Feb-2007
 * Time: 23:51:42
 * To change this template use File | Settings | File Templates.
 */
public class SimpleRMLPController implements Controller, Evolvable {

    RMLP mlp;

    final boolean fixSpeed = false;

    public SimpleRMLPController () {
        this.mlp = new RMLP (4, 4, 2);
    }

    private SimpleRMLPController (RMLP mlp) {
        this.mlp = mlp;
    }

    public int control (SensorModel model) {
        return control( model.getSpeed (),
                        model.getAngleToNextWaypoint (),
                        model.getDistanceToNextWaypoint () );
    }

    public int control (double speed, double angle, double distance) {
        double[] inputs = { 1, speed, angle, distance };
        double[] output = mlp.propagate (inputs);
        int driving = output[0] < -0.3 ? 0 : (output[0] > 0.3 ? 2 : 1);
        int steering = output[1] < -0.3 ? 0 : (output[1] > 0.3 ? 2 : 1);
        return driving * 3 + steering;
    }

    public void mutate () {
        mlp.mutate ();
    }

    public Evolvable copy () {
        return new SimpleRMLPController (mlp.copy ());
    }

    public SimpleRMLPController copyExplicit() {
        return new SimpleRMLPController (mlp.copy());
    }

    public void reset () {
        mlp.reset ();
    }
}
